package com.voter.verification;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.core.io.ClassPathResource;
import org.springframework.web.client.RestTemplate;

/**
 * Voter producer application tests to test the voter information
 * and to produce to a consumer.
 * @author rjosula
 *
 */
@SpringBootTest
class VoterProducerApiApplicationTests {

	Logger logger = LogManager.getLogger(VoterProducerApiApplicationTests.class);
	
	@Value("${voterInputFilePath}")
	String voterJsonFile;
	
	/**
	 * Test for producing a voter string through a producer.
	 * @throws IOException 
	 */
	@Test
	void voterProducer(){
		
		logger.info("voterJsonFile "+ voterJsonFile);
		String voterInput = "";
		try {
		File resource = new ClassPathResource(voterJsonFile).getFile();
		voterInput = new String(Files.readAllBytes(resource.toPath()));
		} catch(Exception ex) {
		}
		if(voterInput.isEmpty()) {
			logger.throwing(new Exception("File Doesn't exists and test is failure."));
		}
		RestTemplate restCall = new RestTemplate();
		String url = "http://localhost:8080/voter/verificationapp/sendVoterInfo";
		
		String response = restCall.postForObject(url, voterInput, String.class);
		if(response != null) {
			logger.info("Response achieved is:: " + response);
		}
		
	}

}
